##############################################################################
# Module : abc_okc_proc.py
# Author : Old King Cole
# Date   : 04/16/2023
#
# Description : Checker for the end of process of ABC_OKC
#
##############################################################################

import sys, os, wx
from utility import Stderr
sys.stderr = Stderr()
from time import sleep
from commandline import getCommandLine
from Dialogs.exitdlg import ExitDialog


class ABCProc(wx.App):
    def __init__(self, x, params):
        self.pos = (int(params[0]), int(params[1]))
        self.msg = ' '.join(params[2:])
        wx.App.__init__(self, x)

    def OnInit(self):
        self.showProc(self.pos, self.msg)
        return True

    def showProc(self, pos, msg):
        if self.isRunning():
            self.exitdialog = ExitDialog(msg, pos)
            self.exitdialog.Show()
            sleep(1)
            while self.isRunning():
                sleep(1)
            self.exitdialog.Destroy()

    def isRunning(self):
        for p in os.popen('tasklist /FI "IMAGENAME eq abc_okc.exe" /NH').read().split('\n'):
            if "abc_okc.exe" in p.lower():
                return True
        return False

    def OnExit(self):
        return 0


app = ABCProc(0, getCommandLine()[1:])
app.MainLoop()
